# -*- coding: utf-8 -*-
from setuphelpers import *

appx_package_name = "Passbolt.Passbolt"

def install():
    bin_path = glob.glob(f"Passbolt.passbolt*.msixbundle")[0]
    add_appx_cmd = rf'c:\windows\System32\Dism.exe /Online /Add-ProvisionedAppxPackage /PackagePath:"{bin_path}" /SkipLicense'

    appxprovisionedpackage = run_powershell(f'Get-AppxProvisionedPackage -Online | Where-Object DisplayName -Like "{appx_package_name}"')

    if appxprovisionedpackage is None:
        appxprovisionedpackage = {"Version": "0"}

    if force:
        uninstall()

    if Version(appxprovisionedpackage["Version"]) < Version(control.get_software_version()):
        print(f"Installing: {bin_path.split(os.sep)[-1]} ({control.get_software_version()})")
        killalltasks(ensure_list(control.impacted_process))
        run(add_appx_cmd)
    else:
        print(f'{appxprovisionedpackage["PackageName"]} is already installed and up-to-date.')

    appxprovisionedpackage = run_powershell(f'Get-AppxProvisionedPackage -Online | Where-Object DisplayName -Like "{appx_package_name}"')
    if appxprovisionedpackage is None:
        remove_appx(appx_package_name, remove_all=False)
        appxprovisionedpackage = {"Version": "0"}

    if Version(appxprovisionedpackage["Version"]) < Version(control.get_software_version()):
        error('Last version for %s is %s' % (appx_package_name,appxprovisionedpackage["Version"]))

def uninstall():
    appxprovisionedpackage = run_powershell(f'Get-AppxProvisionedPackage -Online | Where-Object DisplayName -Like "{appx_package_name}"')

    if appxprovisionedpackage != None :
        packagename = appxprovisionedpackage['PackageName']
        run(r'c:\windows\System32\Dism.exe /Online /Remove-ProvisionedAppxPackage /PackageName:%s /allusers' % packagename)



def audit():
    audit_result = "OK"
    audit_version = True
    appxprovisionedpackage = run_powershell(f'Get-AppxProvisionedPackage -Online | Where-Object DisplayName -Like "{appx_package_name}"')

    if appxprovisionedpackage is None:
        print(f"{appx_package_name} is not installed.")
        audit_result = "ERROR"

    elif audit_version:
        if Version(appxprovisionedpackage.get("Version", "0")) < Version(control.get_software_version()):
            print(
                f'{appxprovisionedpackage["PackageName"]} is installed in version: {appxprovisionedpackage["Version"]} instead of: {control.get_software_version()}.'
            )
            audit_result = "WARNING"
        else:
            print(f'{appxprovisionedpackage["PackageName"]} is installed and up-to-date.')
    else:
        print(f'{appxprovisionedpackage["PackageName"]} is installed.')

    return audit_result